import * as Router from 'koa-router';
import * as validators from './validators';
export interface ParamError {
    path: string | number;
    value: any;
    failed: string;
    reason?: string;
}
export interface ParamsContext {
    errors?: ParamError[];
}
export interface ParamsOptions {
    [key: string]: null | validators.Validator | validators.Validator[];
}
export interface StandardParamsOptions {
    key: string;
    validators: validators.Validator[];
}
export declare function params(options: ParamsOptions): Router.IMiddleware;
export declare function processValidators(target: any, standardOptions: StandardParamsOptions[], root: any): ParamError[];
